SystemOrganization addCategory: 'OrbeonAdHocProcessCore'!

Exception subclass: #OrbeonAdHocException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonAdHocProcessCore'!

Object subclass: #AdHocObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonAdHocProcessCore'!

AdHocObject subclass: #AdHocProcessDefinition
	instanceVariableNames: 'applications name users roles formDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonAdHocProcessCore'!

!AdHocProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/02/2016 15:23'!
newWithAll: collectionOfApplications

	^super new initialize
		applications: collectionOfApplications;
		yourself! !

!AdHocProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2016 14:45'!
addApplication: anAbstractApplication

	^applications add: anAbstractApplication! !

!AdHocProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 09/02/2016 10:14'!
addFormDefinition: anOrbeonPublishedFormDefinition

	^formDefinitions add: anOrbeonPublishedFormDefinition! !

!AdHocProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/02/2016 15:14'!
applications
	^applications! !

!AdHocProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/02/2016 15:14'!
applications: newValue
	applications := newValue! !

!AdHocProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 09/02/2016 10:25'!
createInstance

	^AdHocProcessInstance newWith: self! !

!AdHocProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/02/2016 09:58'!
formDefinitions
	^formDefinitions! !

!AdHocProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/02/2016 09:58'!
formDefinitions: newValue
	formDefinitions := newValue! !

!AdHocProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 09/02/2016 15:29'!
grantRole: aRole to: anOrbeonPublishedFormDefinition

	^roles at: aRole 
			ifAbsent: [roles at: aRole put: (OrderedCollection with: anOrbeonPublishedFormDefinition)] 
			ifPresent: [:collection | collection add: anOrbeonPublishedFormDefinition ]! !

!AdHocProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 09/02/2016 15:32'!
grantUser: aUser to: anOrbeonPublishedFormDefinition

	^users at: aUser 
			ifAbsent: [users at: aUser put: (OrderedCollection with: anOrbeonPublishedFormDefinition)] 
			ifPresent: [:collection | collection add: anOrbeonPublishedFormDefinition]! !

!AdHocProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 09/02/2016 15:14'!
initialize

	super initialize.

	applications := OrderedCollection new.
	formDefinitions := OrderedCollection new.
	roles := Dictionary new.
	users :=  Dictionary new.! !

!AdHocProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/02/2016 09:58'!
name
	^name! !

!AdHocProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/02/2016 09:58'!
name: newValue
	name := newValue! !

!AdHocProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 09/02/2016 10:15'!
removeFormDefinition: anOrbeonPublishedFormDefinition

	^formDefinitions remove: anOrbeonPublishedFormDefinition ifAbsent: []! !

!AdHocProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/02/2016 09:58'!
roles
	^roles! !

!AdHocProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/02/2016 09:58'!
roles: newValue
	roles := newValue! !

!AdHocProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/02/2016 09:58'!
users
	^users! !

!AdHocProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/02/2016 09:58'!
users: newValue
	users := newValue! !
